/*
 *
 * nucleo/core/TimeKeeper.cxx --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/config.H>

#include <nucleo/core/ReactiveEngine.H>
#include <nucleo/core/TimeKeeper.H>

#ifdef HAVE_AGL
#include <nucleo/core/carbon/cTimeKeeper.H>
#endif
#include <nucleo/core/select/sTimeKeeper.H>

namespace nucleo {

  // -----------------------------------------------------------------------------

  TimeKeeper*
  TimeKeeper::create(void) {
#ifdef HAVE_AGL
    if (ReactiveEngine::useNativeEngine()) return (TimeKeeper*)(new cTimeKeeper()) ;
#endif
    return (TimeKeeper*)(new sTimeKeeper()) ;
  }

  // -----------------------------------------------------------------------------

}
