#ifndef n_sReactiveEngine_H
#define n_sReactiveEngine_H

/*
 *
 * nucleo/core/select/sReactiveEngine.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/ReactiveEngine.H>

#include <queue>

namespace nucleo {

  class sReactiveEngine : public ReactiveEngineImplementation {

  private:

    bool _running ;

    std::queue<ReactivePair> _objectsToNotify ;

    friend class ReactiveEngine ;

    sReactiveEngine(void) ;

  public:

    ~sReactiveEngine(void) ;

    void notify(ReactiveObject *notified, Observable *notifier) ;
    
    int step(long milliseconds=-1) ;

    void run(void) ;
    void stop(void) ;

  } ;

}

#endif
