#ifndef n_sTimeKeeper_H
#define n_sTimeKeeper_H

/*
 *
 * nucleo/core/select/sTimeKeeper.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/select/sReactiveEngine.H>

#include <nucleo/core/TimeKeeper.H>

namespace nucleo {

  // ---------------------------------------------------------------

  class sTimeKeeper : public TimeKeeper {

  private:

    bool _repeat ;
    unsigned long _delay ;
    unsigned long _epoch ;

  protected:

    static std::list<sTimeKeeper*> _instances ;

    friend class TimeKeeper ;
    friend class sReactiveEngine ;

    sTimeKeeper() ;
    void _checkTime(void) ;

  public:

    ~sTimeKeeper() ;

    void arm(unsigned long milliseconds, bool repeat=false) ;
    void disarm(void) ;
    long getTimeLeft(void) ;

  } ;

  // ---------------------------------------------------------------

}

#endif
