/*
 *
 * nucleo/network/tcp/TcpUtils.cxx --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/config.H>

#include <nucleo/network/tcp/TcpUtils.H>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/time.h>

#include <signal.h>

namespace nucleo {

  void
  setDefaultTcpSocketOptions(int sock, bool server) {
    int one=1 ;

#if 0
    setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, (void *)&one, sizeof(int)) ;
#ifdef TCP_FASTACK
    setsockopt(sock, IPPROTO_TCP, TCP_FASTACK, (void *)&one, sizeof(int)) ;
#endif
#endif

    struct timeval one_second = {1,0} ;
#ifdef SO_RCVTIMEO
    setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, (void *)&one_second, sizeof(timeval)) ;
#endif
#ifdef SO_SNDTIMEO
    setsockopt(sock, SOL_SOCKET, SO_SNDTIMEO, (void *)&one_second, sizeof(timeval)) ;
#endif

    if (server) {
	 // so we can restart the server later without having to wait for
	 // the system to release the port
#ifdef SO_REUSEPORT
	 setsockopt(sock, SOL_SOCKET, SO_REUSEPORT, (void *)&one, sizeof(int)) ;
#endif
	 setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void *)&one, sizeof(int)) ;
    }

#ifdef SO_NOSIGPIPE
    setsockopt(sock, SOL_SOCKET, SO_NOSIGPIPE, (void *)&one, sizeof(int)) ;
#else  
    signal(SIGPIPE, SIG_IGN) ;
#endif
  }
  
}
