/*
 *
 * nucleo/utils/TimeUtils.cxx --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/config.H>

#include <nucleo/utils/TimeUtils.H>

#include <sys/time.h>

namespace nucleo {

  // -----------------------------------------------------------------------------

  unsigned long
  getCurrentTimeAsMillisecs(void) {
    struct timeval tv ;
    gettimeofday(&tv, 0) ;
    return tv.tv_sec*1000+tv.tv_usec/1000 ;
  }

  // -----------------------------------------------------------------------------

  void
  Chronometer::start(void) {
    _count = 0 ;
    _running = true ;
    _laps = 0 ;
    _epoch = getCurrentTimeAsMillisecs() ;
  }

  unsigned long
  Chronometer::read(void) {
    if (!_running) return _laps ;
    return getCurrentTimeAsMillisecs()-_epoch ;
  }

  void
  Chronometer::stop(void) {
    _laps = getCurrentTimeAsMillisecs()-_epoch ;  
    _running = false ;
  }

  // -----------------------------------------------------------------------------

}
